 /*
  * UAE - The Un*x Amiga Emulator
  *
  * Save/restore emulator state
  *
  * (c) 1999 Toni Wilen
  */


/* functions to save byte,word or long word
 * independent of CPU's endianess */

extern void save_word_func(uae_u8**,uae_u16);
extern void save_long_func(uae_u8**,uae_u32);
extern void save_byte_func(uae_u8**,uae_u8);

extern uae_u16 restore_word_func(uae_u8**);
extern uae_u32 restore_long_func(uae_u8**);
extern uae_u8 restore_byte_func(uae_u8**);

#define save_word(x) save_word_func(&dst,(x))
#define save_long(x) save_long_func(&dst,(x))
#define save_byte(x) save_byte_func(&dst,(x))

#define restore_word() restore_word_func(&src)
#define restore_long() restore_long_func(&src)
#define restore_byte() restore_byte_func(&src)

/* save, restore and initialize routines for
 * Amiga's subsystems
 *
 * restore_x(uae_u8*): restore subsystem data
 * save_x(int*): save subsystem data
 * reinit_x(void): try to initialize all emulator's
 *  internal variables, called after all subsystems
 *  are restored
*/

extern uae_u8 *restore_ram(uae_u8*);
extern uae_u8 *save_ram(int,int*);

extern uae_u8 *restore_rom(uae_u8*);
extern uae_u8 *save_rom(int,int*);

extern uae_u8 *restore_custom(uae_u8*);
extern uae_u8 *save_custom(int*);

extern uae_u8 *restore_audio(uae_u8*,int);
extern uae_u8 *save_audio(uae_u8*,int);

extern uae_u8 *restore_cpu(uae_u8*);
extern uae_u8 *save_cpu(int*);

extern uae_u8 *restore_fpu(uae_u8*);
extern uae_u8 *save_fpu(int*);

extern uae_u8 *restore_cia(int,uae_u8*);
extern uae_u8 *save_cia(int,int*);

extern uae_u8 *restore_disk(int,uae_u8*);
extern uae_u8 *save_disk(int,int*);

extern void save_state(char *filename, char *description);
extern void restore_state(char *filename);

extern void custom_save_state(void);

extern int savestate_wanted;






