/*
  * UAE - The Un*x Amiga Emulator
  *
  * Definitions for accessing cycle counters on a given machine, if possible.
  *
  * Copyright 1997, 1998 Bernd Schmidt
  */

typedef unsigned long frame_time_t;

#ifdef _WIN32
#ifdef _MSC_VER
extern __inline frame_time_t read_processor_time_cyrix( void );
#define read_processor_time read_processor_time_cyrix
#else
extern __inline frame_time_t read_processor_time (void);
#endif
#else  /* %%% - BERND, I don't want this one, but instead the one from win32.c */
static inline frame_time_t read_processor_time (void)
{
    frame_time_t foo;
    /* Don't assume the assembler knows rdtsc */
    __asm__ __volatile__ (".byte 0x0f,0x31" : "=a" (foo) :);
    return foo;
}
#endif