/* 
  * UAE - The Un*x Amiga Emulator
  * 
  * Win32-specific header file
  * 
  * (c) 1997 Mathias Ortmann
  */

extern int atime, acount;

#define UAEWINVERSION "0.8.8"
#define UAEWINRELEASE "5"
#define PROGNAME "WinUAE " UAEWINVERSION ", Release " UAEWINRELEASE

// win32glue.c functions
extern int my_kbd_handler (int, int, int);

// win32.c functions
extern void toggle_fullscreen (void);
extern int currtime (void);
extern void setup_brkhandler (void);
extern void remove_brkhandler (void);
extern void DisplayGUI(int);

extern int checkkey (int vkey, long lParam);
extern void setmouseactive (int active);
extern uae_u32 OSDEP_minimize_uae(void);
extern int gunzip_hack (const char *src, const char *dst);

// globals
extern int bActive;
//extern int draw_all;

//extern int vpos;
//extern unsigned short lof;
extern int capslock;

extern int process_desired_pri;

extern int toggle_sound, bytesinbuf;

#define USE_ZFILE

void fname_wtoa(unsigned char *);
void fname_atow(const char *, char *, int);
int adjust_screenmode (int *pwidth, int *pheight, int *ppixbits);
int start_ddraw (void);
void release_ddraw (void);

extern int sound_available;
extern int framecnt;
extern char prtname[];
extern char VersionStr[256];

struct win32_displaymode {
    struct win32_displaymode *next;
    int width;
    int height;
    int refreshrate;
    /* Bit mask of RGBFF_xxx values.  */
    uae_u32 colormodes;
};

extern struct win32_displaymode *win32_displaymode_list;

/* For StatusBar when running in a Window */
#define NUM_PARTS 7
#define LED_WIDTH 50
#define DRIVE_WIDTH 24
#define FPS_WIDTH 60

extern HKEY hWinUAEKey;

#include "osdep/win32gui.h"
#include "osdep/resource.h"